          #include <P16F628A.INC>
            LIST        p=16F628A    ; 
            __CONFIG    H'3F0A'      ;  H'3F18'
                                    ; 
            
Sec           equ         20h  ;
Sec1          equ         21h   ; 
Sec2          equ         22h   ;
t1vrL         equ         23h   ;
t1vrLL        equ         24h    ;
t1vrH         equ         25h
t1vrHH        equ         26h    ;
t1grL         equ         27h
t1grLL        equ         28h
t1grH         equ         29h
t1grHH        equ         2Ah
tmp_off       equ         2Bh
skor          equ         2Ch
shet          equ         2Dh
eepsec        equ         00A0h
shet_tmr2     equ         2Eh




vremya        equ         36h               ;   
kolbyte       equ         37h               ; -  
reg           equ         38h               ;    
shets         equ         39h               ; -  
FSR_osn       equ         4Ah               ;     
FSR_prer      equ         4Bh               ;  



data1         equ         60h               ;    

flag          equ         7Ch               ;  
flag1         equ         7Dh               ;  
W_TEMP        equ         7Eh
STATUS_TEMP   equ         7Fh    ;

#DEFINE       dat         PORTB,7           ; 
#DEFINE       led_ok      PORTA,3
#DEFINE       post_reg    PORTA,4

#DEFINE       serv_gor    PORTB,4
#DEFINE       serv_vert   PORTB,5
#DEFINE       kan_1       PORTB,6
#DEFINE       kan_2       PORTA,1

#DEFINE       right        PORTB,1
#DEFINE       left         PORTB,0
#DEFINE       down         PORTB,2
#DEFINE       up           PORTB,3 

   
;flag1,2        1
;flag1,3        2
;flag1,4           EEPROM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;    4-  
;     4 ,   1 

              org         0000h           ;     0000h
              goto        Start           ;   Start
           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  

              org         0004h             ;     0004h
       
              movwf       W_TEMP            ;   
              swapf       STATUS,W          ;
              clrf        STATUS            ;
              movwf       STATUS_TEMP       ;
                 
              
              btfsc       INTCON,RBIF
              goto        prov_tmr0
              btfsc       PIR1,TMR1IF
              goto        prov_tmr1
              btfsc       PIR1,TMR2IF
              goto        prov_tmr2
              
prov_tmr0     movf        TMR0,W            ;   TMR0 
              movwf       vremya            ;  vremya 
              movlw       .0                ;  0   TMR0
              movwf       TMR0 

              movf        FSR,W             ;   FSR 
              movwf       FSR_osn           ; FSR_osn
              movf        FSR_prer,W        ;   FSR_prer 
              movwf       FSR               ; FSR

              btfsc       INTCON,T0IF       ;     TMR0
              goto        outshet           ; TMR0:   outshet

              btfss       dat               ;  TMR0:   
              bcf         flag,0            ;dat  0-   flag1
              btfsc       dat
              bsf         flag,0

             
              movlw       .20               ;   .20
              subwf       vremya,W          ;:- 40
              btfss       STATUS,C          ;
              goto        eror              ;  40:   eror
              movlw       .70               ;  40: :  .70
              subwf       vremya,W          ;- 140
              btfsc       STATUS,C          ;
              goto        int1              ;  140:   int1
              bcf         flag,1            ;  140: 1-   flag:
                                            ;   100
              goto        opred             ;   opred
int1          movlw       .80               ; : - 160 .80
              subwf       vremya,W          ;
              btfss       STATUS,C          ;
              goto        eror              ;  160:   eror
              movlw       .130              ;  160: :  .130
              subwf       vremya,W          ;- 260
              btfsc       STATUS,C          ;
              goto        eror              ;  260:   eror
              bsf         flag,1            ;  260: 1-   
                                            ;flag:   200
opred         btfss       flag,0            ;     dat
              goto        int2              ;   dat:   int2
              btfsc       flag,1            ;   dat(  - 
                                            ;-  ):  
              bsf         flag,2            ; 2-   flag: 
              btfss       flag,1            ;   200
              bcf         flag,2            ; 2-   flag: 
                                            ;   100
              bsf         flag,7            ; 7-   flag: 
                                            ;     -
                                            ;-    
              goto        vihod             ;   vihod

int2          btfss       flag,7            ;   dat:(  -
                                            ;-  ):    
                                            ; 
              goto        vihod             ;     :  
                                            ; vihod
              btfsc       flag,2            ;     :- 
                                            ;-    
              goto        int3              ;    200:   int3
              btfss       flag,1            ;    100:  
                                            ;  
              goto        eror              ;   100(   100)-
                                            ;- :   eror 
              bsf         flag,3            ;   200(  100)- 
                                            ;-   (.1)
              goto        intpriem          ;   intpriem

int3          btfsc       flag,1            ;    200:  
                                            ;  
              goto        eror              ;   200(   200)-
                                            ;- :   eror 
              bcf         flag,3            ;   100(  200)-
                                            ;-   (.0)

intpriem      btfsc       flag,3            ;       0- -
              bsf         reg,0             ;- reg
              btfss       flag,3            ;
              bcf         reg,0             ;
              incf        shets,F           ;  (shets)  
              movlw       .8                ;  (shets)     
              xorwf       shets,W           ;  8
              btfsc       STATUS,Z          ;
              goto        srav              ; , 8 (1 ):   srav
              rlf         reg,F             ; :  reg    
                                            ;   
              goto        vihod             ;   vihod

srav          movf        reg,W             ;   - 
              movwf       INDF              ;-  
              incf        FSR,F             ;  FSR:   
                                            ;
              clrf        shets             ;  
              incf        kolbyte,F         ;  -  
              movlw       .2                ;  (shets)    
              xorwf       kolbyte,W         ;  2
              btfss       STATUS,Z          ;
              goto        vihod             ; :   vihod
              bsf         flag,4            ; , 2 :  -
                                            ;-! 
              goto        eror              ;   eror

outshet       bcf         INTCON,T0IF       ;     TMR0
eror          clrf        shets             ;  
              clrf        kolbyte           ;  
              bcf         flag,7            ;     . 
              movlw       data1             ;     
              movwf       FSR               ;   FSR
 
vihod         movf        PORTB,W           ;  PORTB   
              bcf         INTCON,RBIF       ;      
                                            ;  RB4-RB7
             
kon1          movf        FSR,W             ;   FSR 
              movwf       FSR_prer          ; FSR_prer
              movf        FSR_osn,W         ;   FSR_osn 
              movwf       FSR               ; FSR
              goto        exxit

prov_tmr2     bcf         T2CON,TMR2ON
              movlw       .122               ;2 
              xorwf       shet_tmr2,W
              btfss       STATUS,Z
              goto        tm2_inc
              clrf        shet_tmr2
              clrf        TMR2
              bcf         PIR1,TMR2IF
              bsf         flag1,4
              goto        exxit

tm2_inc       incf        shet_tmr2,F
              bcf         PIR1,TMR2IF
              bsf         T2CON,TMR2ON
              goto        exxit

prov_tmr1     bcf         T1CON,TMR1ON
              btfsc       flag1,1
              goto        t3
              btfsc       flag1,0
              goto        t2

t1            movf        t1grH,W
              movwf       TMR1H
              movf        t1grL,W
              movwf       TMR1L
              bsf         flag1,0
              bsf         serv_gor
              goto        extmr1

t2            bcf         serv_gor
              movf        t1vrH,W
              movwf       TMR1H
              movf        t1vrL,W
              movwf       TMR1L
              bsf         flag1,1
              bsf         serv_vert
              goto        extmr1

t3            bcf         serv_vert
              bcf         flag1,1
              bcf         flag1,0
              btfss       post_reg
              goto        extmr1
              movlw       .20
              xorwf       tmp_off,W
              btfss       STATUS,Z
              goto        extmr2
              clrf        tmp_off
              bcf         PIR1,TMR1IF
              goto        exxit
extmr2        incf        tmp_off,F

extmr1        bcf         PIR1,TMR1IF
              bsf         T1CON,TMR1ON
                


exxit         swapf       STATUS_TEMP,W     ;   
              movwf       STATUS            ;
              swapf       W_TEMP,F          ;
              swapf       W_TEMP,W          ;
                                            ;
              retfie                        ;    

             

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
                                 
             
Start         movlw       b'00000000'
              movwf       PORTB
              movlw       b'00000000'
              movwf       PORTA
              
              movlw       b'00000111'
              movwf       CMCON

              bsf         STATUS,RP0        
              movlw       b'10001111'          
              movwf       TRISB
              movlw       b'11110101'          
              movwf       TRISA
              
           
              movlw       b'10000010'       ;  TMR0 1:8, .  b'10000000'
              movwf       OPTION_REG        ; 
              bcf         STATUS,RP0
           
              clrf        flag1
              bcf         flag,7            ;     .
              bcf         flag,4            ;    
              clrf        shets             ;  
              clrf        kolbyte           ;  
              movlw       data1             ;     
              movwf       FSR_prer          ;  FSR_prer

              clrf        tmp_off
              clrf        shet_tmr2

              bsf         STATUS,RP0
              movlw       0x00
              movwf       EEADR
              bsf         EECON1,RD
              movf        EEDATA,W
              bcf         STATUS,RP0
              movwf       skor
              
              movlw       .14
              subwf       skor,W
              btfss       STATUS,C
              goto        standrt
              movf        skor,W
              sublw       .136   ;68
              btfsc       STATUS,C 
              goto        met_dal 
standrt       movlw       .44               ;  
              movwf       skor
 

met_dal       bsf         STATUS,RP0        ;    
              movlw       0x01
              movwf       EEADR
              bsf         EECON1,RD
              movf        EEDATA,W
              bcf         STATUS,RP0
              movwf       t1vrHH
 
              movlw       .8               ;    EEPROM 
              subwf       t1vrHH,W
              btfss       STATUS,C
              goto        zap_std1

              movf        t1vrHH,W
              sublw       .38
              btfss       STATUS,C
              goto        zap_std1

              bsf         STATUS,RP0        ;    
              movlw       0x02
              movwf       EEADR
              bsf         EECON1,RD
              movf        EEDATA,W
              bcf         STATUS,RP0
              movwf       t1vrLL
              goto        zap_std2
  
zap_std1      movlw       .22              ;   
              movwf       t1vrHH
              movlw       .232              
              movwf       t1vrLL    

zap_std2      bsf         STATUS,RP0        ;    
              movlw       0x03
              movwf       EEADR
              bsf         EECON1,RD
              movf        EEDATA,W
              bcf         STATUS,RP0
              movwf       t1grHH
          
              movlw       .8               ;    EEPROM 
              subwf       t1grHH,W
              btfss       STATUS,C
              goto        zap_std3

              movf        t1grHH,W
              sublw       .38
              btfss       STATUS,C
              goto        zap_std3

              bsf         STATUS,RP0        ;    
              movlw       0x04
              movwf       EEADR
              bsf         EECON1,RD
              movf        EEDATA,W
              bcf         STATUS,RP0
              movwf       t1grLL
              goto        zap_std4

zap_std3      movlw       .22              ;   
              movwf       t1grHH
              movlw       .232              
              movwf       t1grLL    


zap_std4      comf        t1vrLL,W
              movwf       t1vrL
              comf        t1vrHH,W
              movwf       t1vrH

              comf        t1grLL,W
              movwf       t1grL
              comf        t1grHH,W
              movwf       t1grH

              movlw       b'00000000'       ;. TMR1 1:1,     
              movwf       T1CON
              
              clrf        TMR1L
              
              clrf        TMR1H
              bsf         INTCON,PEIE       ;. . . 
              bcf         PIR1,TMR1IF       ;  .  . TMR1
              bsf         STATUS,RP0
              bsf         PIE1,TMR1IE       ;. .  . TMR1
              bcf         STATUS,RP0
              
              bsf         T1CON,TMR1ON      ; TMR1
 
              movlw       b'01111011'       ;. TMR2-1:16,   TMR2-1:16
              movwf       T2CON             
              clrf        TMR2
              bcf         PIR1,TMR2IF       ;  .  . TMR2

              bsf         STATUS,RP0
              movlw       0xFF
              movwf       PR2
              bsf         PIE1,TMR2IE       ;. .  . TMR2
              bcf         STATUS,RP0
              
              clrf        TMR0
              bcf         INTCON,T0IF       ;     TMR0
              bsf         INTCON,T0IE       ;    TMR0

              movf        PORTB,W           ;  PORTB   
              bcf         INTCON,RBIF       ;       RB4:RB7
              bsf         INTCON,RBIE       ;      RB4:RB7
              bsf         INTCON,GIE        ;  
              
            

oprosknp      btfsc       right  
              goto        met_op1
              btfss       left
              goto        pr_skor
              call        kp2
              call        pausknp
met_op1       btfsc       left
              goto        met_op2
              btfss       right
              goto        pr_skor
              call        kp3
              call        pausknp
met_op2       btfsc       up
              goto        met_op3
              call        kp0
              call        pausknp
met_op3       btfsc       down  
              goto        met_op4
              call        kp1
              call        pausknp
met_op4       btfss       flag,4
              goto        met_op5
              bsf         led_ok
              call        priem1
              bcf         led_ok
met_op5       btfss       flag1,4
              goto        oprosknp
              bcf         flag1,4
              call        zap_pol
              goto        oprosknp



priem1        bcf         flag,4            ; :   
              movlw       data1             ;
              movwf       FSR               ;
              movf        INDF,W
              
              incf        FSR,F
              xorwf       INDF,W
              btfss       STATUS,Z
              return
              movlw       .11
              xorwf       INDF,W
              btfss       STATUS,Z
              goto        met_1
              call        kp3
              return

met_1         movlw       .22
              xorwf       INDF,W
              btfss       STATUS,Z
              goto        met_2
              call        kp2
              return

met_2         movlw       .33
              xorwf       INDF,W
              btfss       STATUS,Z
              goto        met_3
              call        kp1
              return

met_3         movlw       .44
              xorwf       INDF,W
              btfss       STATUS,Z
              goto        met_4
              call        kp0
              return

met_4         movlw       .15
              xorwf       INDF,W
              btfss       STATUS,Z
              goto        met_40
 
              btfsc       flag1,2
              goto        met_11
              bsf         kan_1
              bsf         flag1,2
              return

met_11        bcf         kan_1
              bcf         flag1,2
              return

met_40        movlw       .25
              xorwf       INDF,W
              btfss       STATUS,Z
              return
 
              btfsc       flag1,3
              goto        met_13
              bsf         kan_2
              bsf         flag1,3
              return

met_13        bcf         kan_2
              bcf         flag1,3
              return

pr_skor       bcf         INTCON,T0IE       ;    TMR0
              bcf         INTCON,RBIE       ;      RB4:RB7
              bsf         led_ok
met_pr1       call        pausknp
              btfss       left
              goto        met_pr1
              btfss       right
              goto        met_pr1

;knp_pr        btfsc       right  
;              goto        met_p1
;              btfss       left
;              goto        exit_pr
;              call        uvel_skor


;met_p1        btfsc       left
;              goto        met_p2
;              btfss       right
;              goto        exit_pr
;              call        umen_skor

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

knp_pr        btfsc       right            ; 1- 
              goto        met_p1        ;1-   :    2-  
              movlw       .15            ;1-  :   100   shet
              movwf       shet
kn1           call        paus_pr         ;  (5-20)
              btfsc       right            ; 1- 
              goto        prog1           ;1-  :    prog1
              btfss       left
              goto        exit_pr
              decfsz      shet,F          ;1-   :   shet
              goto        kn1             ;    0:    kn1
kn11          call        uvel_skor        ;   0:   program1
              
              btfsc       right           ; 1- 
              goto        met_p1        ;1-  :    oproskn2 
              goto        kn11            ;1-   :    kn11  
                                          ;   program1
 
prog1         call        uvel_skor        ;  program1
 
met_p1        btfsc       left            ; 1- 
              goto        met_p2        ;1-   :    2-  
              movlw       .15            ;1-  :   100   shet
              movwf       shet
kn2           call        paus_pr         ;  (5-20)
              btfsc       left            ; 1- 
              goto        prog2           ;1-  :    prog1
              btfss       right
              goto        exit_pr
              decfsz      shet,F          ;1-   :   shet
              goto        kn2             ;    0:    kn1
kn22          call        umen_skor        ;   0:   program1
             
              btfsc       left           ; 1- 
              goto        met_p2        ;1-  :    oproskn2 
              goto        kn22            ;1-   :    kn11  
                                          ;   program1
 
prog2         call        umen_skor        ;  program1
                                          ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
           
met_p2        btfsc       up
              goto        met_p3
              call        kp0
              call        pausknp
met_p3        btfsc       down  
              goto        knp_pr
              call        kp1
              call        pausknp
              goto        knp_pr
              

umen_skor     movf        skor,W               ;
              sublw       .135     ;67
              btfss       STATUS,C
              return
              incf        skor,F
              bcf         led_ok
              call        paus_pr
              bsf         led_ok
              call        paus_pr
              return


uvel_skor     movlw       .15               ;
              subwf       skor,W
              btfss       STATUS,C
              return
              decf        skor,F
              bcf         led_ok
              call        paus_pr
              bsf         led_ok
              call        paus_pr
              return


exit_pr      btfsc       post_reg
             goto        eep2
eep3         btfsc       flag1,1
             goto        eep3
             btfsc       flag1,0
             goto        eep3
             bcf         T1CON,TMR1ON
             goto        eep4
eep2         btfsc       T1CON,TMR1ON
             goto        eep2
eep4         bsf         STATUS,RP0
             movlw       .3
             movwf       eepsec
pov_eep      bcf         STATUS,RP0
             movf        skor,W
             bsf         STATUS,RP0
             movwf       EEDATA          
             movlw       0x00
             movwf       EEADR
             bsf         EECON1,WREN
              movlw       0x55
              movwf       EECON2
              movlw       0xAA
              movwf       EECON2
              bsf         EECON1,WR  
eep1          btfsc       EECON1,WR
              goto        eep1
              bcf         EECON1,WREN

             movf        EEDATA,W
             bsf         EECON1,RD
             subwf       EEDATA,W
             btfsc       STATUS,Z
             goto        eep_ok
             decfsz      eepsec,F
             goto        pov_eep
            
             
eep_ok        bcf         STATUS,RP0
              btfss       post_reg
              bsf         T1CON,TMR1ON
met_ee1       call        pausknp
              btfss       left
              goto        met_ee1
              btfss       right
              goto        met_ee1
             clrf        TMR0
             bcf         INTCON,T0IF       ;     TMR0
             bsf         INTCON,T0IE       ;    TMR0

              movf        PORTB,W           ;  PORTB   
              bcf         INTCON,RBIF       ;       RB4:RB7
              bsf         INTCON,RBIE       ;      RB4:RB7
              bcf         led_ok
              goto        oprosknp

              


kp0           movlw       .13                ;   
              subwf       t1vrHH,W             ;   
              btfss       STATUS,C          ;
              return                        ;  600 ,    
                                            ;,    povorot_1
              btfss       STATUS,Z          ;
              goto        kpp1              ;  600 ,    met_p11 
              movlw       .16               ;
              subwf       t1vrLL,W             ;
              btfss       STATUS,C          ;
              return                        ;  600 ,   
                                            ;,    povorot_1

kpp1          call        tm2_pusk
              movlw       .42               ;   
              subwf       t1vrLL,F             ; 10 
              btfsc       STATUS,C          ;
              goto        kpp2            ;
              decf        t1vrHH,F             ;
kpp2          call        perezap1          ;  perezap
              return                        ;   


kp1           movf        t1vrHH,W          ;   
              sublw       .32                ;  
              btfss       STATUS,C          ;
              return                        ;  2,5 ,   
                                            ;,    povorot_2 
              btfss       STATUS,Z          ;  
              goto        kpa1             ;  2,5 :    met_p21
              movf        t1vrLL,W             ;
              sublw       .192              ;
              btfss       STATUS,C          ;
              return                        ;  2,5 ,   
                                            ;,    povorot_2

kpa1          call        tm2_pusk
              movlw       .42              ;   
              addwf       t1vrLL,F             ; 10 
              btfss       STATUS,C          ;
              goto        kpa2           ;
              incf        t1vrHH,F             ;
kpa2          call        perezap1           ;  perezap
              return                        ;  

perezap1      bsf         STATUS,RP0
              bcf         PIE1,TMR1IE       ;. .  . TMR1
              bcf         STATUS,RP0
              comf        t1vrLL,W
              movwf       t1vrL
              comf        t1vrHH,W
              movwf       t1vrH
              clrf        tmp_off           ;     
              bsf         T1CON,TMR1ON
              bsf         STATUS,RP0
              bsf         PIE1,TMR1IE       ;. .  . TMR1
              bcf         STATUS,RP0
              return


kp2           movlw       .8                ;   
              subwf       t1grHH,W             ;   
              btfss       STATUS,C          ;
              return                        ;  600 ,    
                                            ;,    povorot_1
              btfss       STATUS,Z          ;
              goto        kpb1              ;  600 ,    met_p11 
              movlw       .232               ;
              subwf       t1grLL,W             ;
              btfss       STATUS,C          ;
              return                        ;  600 ,   
                                            ;,    povorot_1

kpb1          call        tm2_pusk
              movlw       .42              ;   
              subwf       t1grLL,F             ; 10 
              btfsc       STATUS,C          ;
              goto        kpb2            ;
              decf        t1grHH,F             ;
kpb2          call        perezap2          ;  perezap
              return                        ;   


kp3           movf        t1grHH,W          ;   
              sublw       .38                ;  
              btfss       STATUS,C          ;
              return                        ;  2,5 ,   
                                            ;,    povorot_2 
              btfss       STATUS,Z          ;  
              goto        kpc1             ;  2,5 :    met_p21
              movf        t1grLL,W             ;
              sublw       .168              ;
              btfss       STATUS,C          ;
              return                        ;  2,5 ,   
                                            ;,    povorot_2

kpc1          call        tm2_pusk
              movlw       .42               ;   
              addwf       t1grLL,F             ; 10 
              btfss       STATUS,C          ;
              goto        kpc2          ;
              incf        t1grHH,F             ;
kpc2          call        perezap2           ;  perezap
              return                        ;  

perezap2      bsf         STATUS,RP0
              bcf         PIE1,TMR1IE       ;. .  . TMR1
              bcf         STATUS,RP0
              comf        t1grLL,W
              movwf       t1grL
              comf        t1grHH,W
              movwf       t1grH
              clrf        tmp_off           ;     
              bsf         T1CON,TMR1ON
              bsf         STATUS,RP0
              bsf         PIE1,TMR1IE       ;. .  . TMR1
              bcf         STATUS,RP0
              return


zap_pol      btfsc       flag1,1
             goto        zap_pol
             btfsc       flag1,0
             goto        zap_pol
             bcf         T1CON,TMR1ON

             bcf         INTCON,GIE

             movf        t1vrHH,W           ;    EEPROM
             bsf         STATUS,RP0
             movwf       EEDATA          
             movlw       0x01
             movwf       EEADR
             call        zap_pol_eep

              bcf         STATUS,RP0
             movf        t1vrLL,W
             bsf         STATUS,RP0
             movwf       EEDATA          
             movlw       0x02
             movwf       EEADR
             call        zap_pol_eep

             bcf         STATUS,RP0
             movf        t1grHH,W
             bsf         STATUS,RP0
             movwf       EEDATA          
             movlw       0x03
             movwf       EEADR
             call        zap_pol_eep

             bcf         STATUS,RP0
             movf        t1grLL,W
             bsf         STATUS,RP0
             movwf       EEDATA          
             movlw       0x04
             movwf       EEADR
             call        zap_pol_eep
              bcf         STATUS,RP0

              btfss       post_reg
              bsf         T1CON,TMR1ON
              
             clrf        TMR0
             bcf         INTCON,T0IF       ;     TMR0
             
              movf        PORTB,W           ;  PORTB   
              bcf         INTCON,RBIF       ;       RB4:RB7
              bsf         INTCON,GIE
              goto        oprosknp


zap_pol_eep   bsf         EECON1,WREN
              movlw       0x55
              movwf       EECON2
              movlw       0xAA
              movwf       EECON2
              bsf         EECON1,WR  
zap_p1        btfsc       EECON1,WR
              goto        zap_p1
              bcf         EECON1,WREN
              return


tm2_pusk      bcf         T2CON,TMR2ON
              clrf        shet_tmr2
              clrf        TMR2
              bsf         T2CON,TMR2ON 
              return       


wait50        movlw       .12                     ; 50
              movwf       Sec
loop50        nop
              decfsz      Sec,F
              goto        loop50
              return

pausknp       movf        skor,W             ; (0,5)x14...68 = 7-34
              movwf       Sec2
p4            movlw       .10                     
              movwf       Sec1
p3            movlw       .67
              movwf       Sec             ;
p2            decfsz      Sec,F           ;
              goto        p2              ;
              decfsz      Sec1,F          ;
              goto        p3              ;
              decfsz      Sec2,F          ;
              goto        p4    
              return                      ;
                                          ;


             
paus_pr       movlw       .3             ; 50 
              movwf       Sec2
pp3           movlw       .87
              movwf       Sec1
pp2           movlw       .255
              movwf       Sec             ;
pp1           decfsz      Sec,F           ;
              goto        pp1              ;
              decfsz      Sec1,F          ;
              goto        pp2  
              decfsz      Sec2,F          ;
              goto        pp3              ;
              return                      






	                 end
